<?php

namespace Drupal\testsuite;

use Drupal\Core\Database\Database;

/**
 * Test Suite Services.
 */
class ConfigService {

    /**
     * Gets the database config.
     *
     * @return array
     *   The database config.
     */
    public function getConfig() {
        $config = \Drupal::config('testsuite.settings');
        $configArray = array();
        switch($config->get('testsuite_mysql_storage_type')) { // 0 module.config, 1 settings.config, 2 env
            case 1:
                $connection_info = Database::getConnectionInfo()['default'];
                $configArray = [
                    'host' => $connection_info['host'],
                    'user' => $connection_info['username'],
                    'pass' => $connection_info['password'],
                    'port' => $connection_info['port'],
                    'database' => $connection_info['database'],
                    'base_url' => \Drupal::request()->getSchemeAndHttpHost(),
                ];
                break;
            case 2: break;
            default:
                $configArray = [
                    'host' => $config->get('testsuite_mysql_host'),
                    'user' => $config->get('testsuite_mysql_username'),
                    'pass' => $config->get('testsuite_mysql_password'),
                    'port' => $config->get('testsuite_mysql_port'),
                    'database' => $config->get('testsuite_mysql_database_name'),
                    'base_url' => $config->get('testsuite_simple_base_url')
                ];
        }
        $configArray['browser_output_directory'] = $config->get('testsuite_browser_output_directory');
        $configArray['browser_output_base_url'] = $config->get('testsuite_browser_output_base_url');
        $configArray['disable_deprecation_testing'] = $config->get('testsuite_disable_deprecation_testing');
        $configArray['selectively_ignore_deprecation'] = $config->get('testsuite_selectively_ignore_deprecation');
        $configArray['selectively_ignore_deprecation_file'] = $config->get('testsuite_selectively_ignore_deprecation_file');
        $configArray['mink_driver_class'] = $config->get('testsuite_mink_driver_class');
        $configArray['mink_driver_args'] = $config->get('testsuite_mink_driver_args');
        $configArray['mink_driver_args_webdriver'] = $config->get('testsuite_mink_driver_args_webdriver');
        return $configArray;
    }
}
