<?php

namespace Drupal\testsuite;

use Symfony\Component\HttpFoundation\Request;

/**
 * Provides an interface defining a testsuite entity.
 */
interface TestInterface {

  /**
   * Gets the module name.
   *
   * @return bool
   *   The module name.
   */
  public function getModuleName();

  /**
   * Gets the menu name.
   *
   * @return bool
   *   The menu item name.
   */
  public function getMenuName();

  /**
   * Gets the test name.
   *
   * @return bool
   *   If the test succeeded or failed.
   */
  public function getName();

  /**
   * Gets the test description.
   *
   * @return bool
   *   If the test succeeded or failed.
   */
  public function getDescription();

  /**
   * Runs the test and returns if the test succeeded or failed.
   *
   * @param Symfony\Component\HttpFoundation\Request $request
   *
   * @return object
   *   If the test succeeded or failed.
   */
  public function runTest(Request $request);

}
