<?php

namespace Drupal\Tests\testsuite\Unit;

use Drupal\Tests\UnitTestCase;
use Drupal\testsuite\GuzzleService;

class GuzzleServiceTest extends UnitTestCase {

    /**
     * @var \Drupal\testsuite\GuzzleService
     */
    protected $_guzzleService;

    /**
     * The mocked wrapped kernel.
     *
     * @var \GuzzleHttp\ClientInterface|\PHPUnit\Framework\MockObject\MockObject
     */
    protected $_httpClient;

    /**
     * {@inheritdoc}
     */
    protected function setUp(): void {
        parent::setUp();
        $this->_httpClient = $this->createMock('GuzzleHttp\ClientInterface');
        $this->_guzzleService = new GuzzleService($this->_httpClient);
    }

    /**
     * Tests that the Test Suite GuzzleService works.
     */
    public function testService() {
        $this->assertContainsOnlyInstancesOf(GuzzleService::class, [$this->_guzzleService]);
    }
}