<?php

namespace Drupal\custom_tests\Tests;

use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\testsuite\TestInterface;
use Symfony\Component\HttpFoundation\Request;

class CheckFor404Errors implements TestInterface {
    use StringTranslationTrait;

    /**
     * @var string $_moduleName
     */
    private $_moduleName = "";

    /**
     * @var string $_menuName
     */
    private $_menuName = "System";

    /**
     * @var string $_name
     */
    private $_name = "Check For 404 Errors";

    /**
     * @var string $_description
     */
    private $_description = "Checks watchdog database for 404 errors.";

    /**
     * Getter for $_moduleName
     *
     * @return string $_moduleName
     */
    public function getModuleName() {
        return $this->_moduleName;
    }

    /**
     * Getter for $_menuName
     *
     * @return string $_menuName
     */
    public function getMenuName() {
        return $this->_menuName;
    }

    /**
     * Getter for $_name
     *
     * @return string $_name
     */
    public function getName() {
        return $this->_name;
    }

    /**
     * Getter for $_description
     *
     * @return string $_description
     */
    public function getDescription() {
        return $this->_description;
    }

    /**
     * Tests that checks for 404 errors.
     */
    public function runTest(Request $request)
    {
        $count = \Drupal::database()->select('watchdog', 'w')
        ->fields('w', array('wid'))
        ->condition('type', 'page not found')
        ->countQuery()
        ->execute()
        ->fetchField();
        if($count == 0) return t('Test Passed');
        else return t('You have 404 errors. Please go to <a href="@page-not-found">Top page not found errors</a> to view them.', array(
            '@page-not-found' => '/admin/reports/page-not-found',
        ));
    }
}